<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
          "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>

<HEAD>
<TITLE>JFLA 99</TITLE>
</HEAD>

<BODY BGCOLOR="#FFFFFF">

<H1 ALIGN=CENTER>JFLA 99: relecture du papier 12</H1>

<P>
Numéro du papier: 12
<P>
Nom du papier et auteurs: Aspects de la programmation d'applications Win32
avec un langage fonctionnel - R. Pucella, E. Meijer, D. Oliva

<H2>1</H2>

<P>
Nom du rapporteur: Manuel Serrano
<P>
Confiance en la note: 2

<P>Notation du papier: 3

<P>Commentaires aux auteurs:

<P>L'article "Aspects de la programmation d'applications Win32 avec un
langage fonctionnel" décrit comme son nom l'indique une méthode
utilisée pour utiliser l'Api Win32 avec le système SML/NJ. Le style de
l'article est agréable. En particulier la présentation de l'Api Win 32
est assez claire. En revanche, il me semble tout de même que l'article
présente quelques lacunes:

<P>- à la lecture de l'article on a un peu de mal à comprendre ce qui a été
fait ici. L'interface externe est dans SML/NJ, le compilateur de spécification
IDL existe déjà. Qu'est-ce que présente exactement cet article ? Est-ce 
juste une description d'une expérience qui a consisté à n'utiliser que
SML/NJ et ML-IDL pour utiliser l'Api Win 32 dans SML/NJ ? Si c'est le cas,
je pense qu'il faudrait le dire plus clairement. Si ce n'est pas le cas
alors il faut changer l'article pour mettre plus en avant ce qui a été
fait.

<P>- est-ce qu'il aurait été possible de s'y prendre autrement pour utiliser
l'Api Win 32 ? Si oui, alors il faudrait dire un mot sur les possibles
alternatives ? Si non, alors je ne comprends pas très bien le sens de
cet article.

<P>- il n'est fait aucune référence à des travaux similaires. D'autres systèmes
de haut niveau ont pourtant dû faire un travail relativement proche. Par
exemple, qu'en est-il des systèmes implantant Java sous Windows ?

<P>- on aurait aimé avoir un peu plus de conclusions:
<P> . à quoi ressemble un programme SML/NJ utilisant l'Api Win 32. 
<P> . est-ce agréable à utiliser ou bien faut il écrire 3 fois plus de code
   qu'en C ?
<P> . quelle est l'efficacité des programmes résultants ?
 . est-ce qu'à un moment donné il faut faire des choses parce que la 
<P>   bibliothèque d'exécution de SML utilise un GC (e.g. que se passe-t-il 
   lorsqu'un objet SML n'est plus pointé que par une structure externe). 
<P> 
Par ailleurs, voici quelques remarques plus ponctuelles.
<P>
Résumé:<BR>
-------<BR>
Il me semble que la première phrase n'est pas très heureuse. Ce n'est pas
le langage qui doit offrir une connexion avec la machine hôte. C'est
l'implantation. Le langage ISO-C ne contient aucune notion liée à X
window par exemple mais on peut programmer X avec C parce que les
implantations de C le permettent. C'est la même chose pour les langages
fonctionnels.
<P>
Introduction:<BR>
-------------<BR>
2ème ligne, "de la de qualité" supprimer le deuxième "de".<BR>

2ème page, 1er paragraphe: "problem" -> "problème"<BR>

2ème page, 2ème paragraphe: Je ne comprends pas bien la phrase
"Nous englobons donc le travail..."
Pourquoi le donc ? Sans savoir en quoi consiste le travail fait sur
Haskell il me semble qu'il est difficile de comprendre la phrase.<BR>

3ème paragraphe: "... Nous voulons éviter de devoir programmer des
aspects de l'application en C..."<BR>
Pourquoi ? Est-ce par pur exercice de style ou y a-t-il une autre
raison ?<BR>

6ème Page: "Inteprétive" n'est pas correct.<BR>

6ème page, dernier paragraphe: À mon avis soit il faut en dire plus
sur les "type library" soit il faut supprimer le paragraphe. Ne sachant
pas ce qu'est une "type library" je ne comprends pas grand chose à ce
paragraphe...<BR>

7ème page, 2ème paragraphe: "supported" -> "implanter du" ou "implanter le"<BR>

7ème page, 2ème paragraphe: "system d'operation" qu'est-ce qu'un système 
d'opération. S'agit il du système d'exploitation ?<BR>

7ème page, 2ème paragraphe: "qui s'enregistre avec le système" ->
"qui s'enregistre auprès du système"<BR>

8ème page, 1er paragraphe: "Il serait utile de d'identifier" ->
"Il serait utile d'identifier"<BR>

Je ne comprends pas la phrase: "L'utilisation d'une FFI étant généralement
... sur la représentation des structures de données". Je crois qu'il faudrait
en dire ici un peu plus.<BR>

8ème page, 2ème paragraphe: "in" -> "dans"<BR>

9ème page, 2ème ligne: "une traducteur" -> "un traducteur"<BR>
9ème page, 3ème ligne: "paramétrisé" -> "paramétré"<BR>

N'étant pas très familier avec SML, et ne sachant pas ce qu'est un type
"naturel", je ne comprends pas le dernier paragraphe de la page 9.<BR>

10ème page, ligne 3: "ce que nous avons" -> "ce dont nous avons"<BR>
10ème page, ligne 4: "qui nous permet" -> "qui nous permette"<BR>

"Pour avoir une utilité maximale, la FFI doit nécessairement être dynamique".
Je ne comprends pas cette phrase. Qu'est-ce que ça signifie qu'une FFI
est dynamique ?<BR>

11ème Page: "toutes les fonctions de l'API Win32 et COM en général sont
implémentés" -> "toutes les fonctions de l'API Win32 et COM sont en général
implantées"<BR>

Page 12. La même formulation a déjà été utilisée dans l'introduction et
je m'aperçois ici que je ne la comprends pas. Que signifie:
"la structure d'un programme inclut la définition de fonctions en charge..." ?
Est-ce que cela signifie que le programme doit définir les fonctions
traitant les message adressés aux différentes fenêtres ?<BR>

Page 12, dernier paragraphe: Là aussi il y a des choses qui m'échappent!
Est-ce que le problème vient du fait qu'il n'est pas possible de convertir
une vraie fermeture (avec un environnement qui ne serait pas vide) SML en
une fonction C ? Par ailleurs, je ne comprends pas bien l'argument sur le
style impératif. Je ne crois pas qu'on puisse s'attendre à programmer des
fenêtres Windows dans un style très fonctionnel.<BR>

<P>Commentaires réservés au comité de programme:
<P>
Je n'ai pas très bien compris cet article. Je ne suis pas parvenu à
voir l'apport des auteurs. J'ai l'impression qu'il s'agit juste d'une
mise en oeuvre d'outils SML déjà existants pour utiliser l'Api Win
32. Lorsque je lis cet article, je ne comprends pas ce qu'ont réalisé
les auteurs. Par ailleurs, le fait qu'il n'y ait aucune comparaison
avec des travaux similaires me met un peu sur mes gardes.

<H2>2</H2>

<P>Nom du rapporteur: Pierre Weis

<P>Confiance en la note: 3

<P>Notation du papier: 4
<P>  1: a rejeter; 2: ininteressant; 3: acceptable;
<P>  4: bon papier; 5: tres bon papier

<P>Commentaires aux auteurs:
Un bon papier. 

<P>Détails:

<P>Page 9: expliquer en deux mots pourquoi la fonction foo retourne un
couple et non un seul entier.

<P>Comment implémentez-vous les unions d'IDL en SML ? Comment
traitez-vous les exceptions ?

<P>Remplacer citePeytonJones98 par \citePeytonJones98

<P>Remplacer partout
<P> librarie par libraIrie
<P> mechanisme par mécanisme
<P> devrit par devrait
<P> /'e par \'e

<P>En règle général il vous faudrait sans doute faire passer un
correcteur orthographique sur votre article.

<P>Commentaires reserves au comite de programme:


<H2>3</H2>

<P>Nom du rapporteur: X. Leroy

<P>Confiance en la note: 3
<P>  1 : je n'ai pas compris car ce n'est pas mon domaine.
<P>  2 : j'ai compris, mais je ne domine pas le sujet.
<P>  3 : j'ai tout compris car c'est mon domaine.

<P>Notation du papier: 4
<P>  1: a rejeter; 2: ininteressant; 3: acceptable;
<P>  4: bon papier; 5: tres bon papier

<P>Commentaires aux auteurs:

<P>Article intéressant et instructif, dans un domaine très "chaud" en ce
moment.

<P>La partie la plus réussie de l'article est la section 2, qui donne une
présentation claire des différents "protocoles" de Win32 et de leurs
relations.

<P>La partie la plus faible est la section 3.  On aimerait plus de
détails sur la génération des "stubs".  En particulier, quel est le
"mapping" des types IDL vers les types SML?  L'article de Meijer et al
à ICFP 98 expliquait assez précisément le mapping IDL -> Haskell.
Au minimum, il faut dire si c'est le même "mapping" qui est employé
ici, et sinon expliquer les principales différences.

<P>Aussi, il serait bon de dire précisément quel sous-ensemble de
Microsoft IDL est reconnu par l'outil ML-IDL.  Microsoft IDL est un
langage complexe et plein de cas particuliers et de bizarreries qui ne
font sens que dans le cadre de C et C++.  Je doute que ML-IDL traite
le langage tout entier.

<P>Commentaires reserves au comite de programme:


</BODY>
</HTML>
